/*
 *	@(#)Box.java 1.7 00/02/10 13:15:11
 *
 * Copyright (c) 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

import javax.media.j3d.*;
import javax.vecmath.*;

public class Box extends Shape3D {

    public Box(double xsize, double ysize, double zsize) {
	super();
	double xmin = -xsize/2.0;
	double xmax =  xsize/2.0;
	double ymin = -ysize/2.0;
	double ymax =  ysize/2.0;
	double zmin = -zsize/2.0;
	double zmax =  zsize/2.0;

	QuadArray box = new QuadArray(24, QuadArray.COORDINATES);

	Point3d verts[] = new Point3d[24];

	// front face
	verts[0] = new Point3d(xmax, ymin, zmax);
	verts[1] = new Point3d(xmax, ymax, zmax);
	verts[2] = new Point3d(xmin, ymax, zmax);
	verts[3] = new Point3d(xmin, ymin, zmax);
	// back face
	verts[4] = new Point3d(xmin, ymin, zmin);
	verts[5] = new Point3d(xmin, ymax, zmin);
	verts[6] = new Point3d(xmax, ymax, zmin);
	verts[7] = new Point3d(xmax, ymin, zmin);
	// right face
	verts[8] = new Point3d(xmax, ymin, zmin);
	verts[9] = new Point3d(xmax, ymax, zmin);
	verts[10] = new Point3d(xmax, ymax, zmax);
	verts[11] = new Point3d(xmax, ymin, zmax);
	// left face
	verts[12] = new Point3d(xmin, ymin, zmax);
	verts[13] = new Point3d(xmin, ymax, zmax);
	verts[14] = new Point3d(xmin, ymax, zmin);
	verts[15] = new Point3d(xmin, ymin, zmin);
	// top face
	verts[16] = new Point3d(xmax, ymax, zmax);
	verts[17] = new Point3d(xmax, ymax, zmin);
	verts[18] = new Point3d(xmin, ymax, zmin);
	verts[19] = new Point3d(xmin, ymax, zmax);
	// bottom face
	verts[20] = new Point3d(xmin, ymin, zmax);
	verts[21] = new Point3d(xmin, ymin, zmin);
	verts[22] = new Point3d(xmax, ymin, zmin);
	verts[23] = new Point3d(xmax, ymin, zmax);

	box.setCoordinates(0, verts);
        setGeometry(box);
	setAppearance(new Appearance());
    }
}
